<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Array Cardio 💪</title>
</head>
<body>
  <p><em>Psst: have a look at the JavaScript Console</em> 💁</p>
  <script>
    // Get your shorts on - this is an array workout!
    // ## Array Cardio Day 1

    // Some data we can work with

    const inventors = [
      { first: 'Albert', last: 'Einstein', year: 1879, passed: 1955 },
      { first: 'Isaac', last: 'Newton', year: 1643, passed: 1727 },
      { first: 'Galileo', last: 'Galilei', year: 1564, passed: 1642 },
      { first: 'Marie', last: 'Curie', year: 1867, passed: 1934 },
      { first: 'Johannes', last: 'Kepler', year: 1571, passed: 1630 },
      { first: 'Nicolaus', last: 'Copernicus', year: 1473, passed: 1543 },
      { first: 'Max', last: 'Planck', year: 1858, passed: 1947 },
      { first: 'Katherine', last: 'Blodgett', year: 1898, passed: 1979 },
      { first: 'Ada', last: 'Lovelace', year: 1815, passed: 1852 },
      { first: 'Sarah E.', last: 'Goode', year: 1855, passed: 1905 },
      { first: 'Lise', last: 'Meitner', year: 1878, passed: 1968 },
      { first: 'Hanna', last: 'Hammarström', year: 1829, passed: 1909 }
    ];

    const people = ['Beck, Glenn', 'Becker, Carl', 'Beckett, Samuel', 'Beddoes, Mick', 'Beecher, Henry', 'Beethoven, Ludwig', 'Begin, Menachem', 
                    'Belloc, Hilaire', 'Bellow, Saul', 'Benchley, Robert', 'Benenson, Peter', 'Ben-Gurion, David', 'Benjamin, Walter', 'Benn, Tony', 
                    'Bennington, Chester', 'Benson, Leana', 'Bent, Silas', 'Bentsen, Lloyd', 'Berger, Ric', 'Bergman, Ingmar', 'Berio, Luciano', 
                    'Berle, Milton', 'Berlin, Irving', 'Berne, Eric', 'Bernhard, Sandra', 'Berra, Yogi', 'Berry, Halle', 'Berry, Wendell', 'Bethea, Erin',
                     'Bevan, Aneurin', 'Bevel, Ken', 'Biden, Joseph', 'Bierce, Ambrose', 'Biko, Steve', 'Billings, Josh', 'Biondo, Frank', 'Birrell, Augustine',
                      'Black, Elk', 'Blair, Robert', 'Blair, Tony', 'Blake, William'];

    // Array.prototype.filter()
    // 1. Filter the list of inventors for those who were born in the 1500's
    // declaramos la constante fifteen y este se convertira en un objeto con Arrays de invetores que son del siglo 16
    // si es verdad se regresara un true y se guardara en el objeto Fifteen, de lo contrario se omitira
      const fifteen = inventors.filter(inventor => (inventor.year > 1500 && inventor.year <= 1600 ));

      console.table(fifteen);
     
    // Array.prototype.map()
    // 2. Give us an array of the inventors first and last names
    //declaramos fullnames y hacemos un mateo, para imprimir unicamente los nombres y apellidos
    const fullNames = inventors.map(inventor => `${inventor.first} ${inventor.last}`);
    console.log(fullNames);

    // Array.prototype.sort()
    // 3. Sort the inventors by birthdate, oldest to youngest
    // declaramos sortBirthdate y usamos .sort para comparar los tamaños de los años
    const sortBirthdate = inventors.sort((a, b) => a.year > b.year ? 1 : 0);
    console.table(sortBirthdate);

    // Array.prototype.reduce()
    // 4. How many years did all the inventors live all together?
    // declaramos totalYears y usamos reduce, para sacar la diferencia de edad
    const totalYear = inventors.reduce((total, inventor) => {
      return total + (inventor.passed - inventor.year);
    }, 0);

    console.log(totalYear);

    // 5. Sort the inventors by years lived
    //hacemos lo mismo que en la anterior, pero aqui compraremos y los ordenamoremos de mayor a menor
    const oldest = inventors.sort(function(a, b){
      const lastOne = a.passed - a.year;
      const nextOne = b.passed - b.year;
      return lastOne > nextOne ? -1 : 1;
    });
    console.table(oldest);

    // 6. create a list of Boulevards in Paris that contain 'de' anywhere in the name
    // https://en.wikipedia.org/wiki/Category:Boulevards_in_Paris
    //
    // const category = document.querySelector('.mw-category');
    // const links = Array.from(category.querySelectorAll('a'));
    // const de = links
    //   .map(link => link.textContent) 
    //   .filter(streetName => streetName.includes('de'));

    // 7. sort Exercise
    // Sort the people alphabetically by last name

    const alpha = people.sort(function(lastOne, nextOne){
      const [aLast, aFirst] = lastOne.split(', ');
      const [bLast, bFirst] = lastOne.split(', ');
      return aLast > bLast ? 1 : -1;
    });

    console.table(alpha);

    // 8. Reduce Exercise
    // Sum up the instances of each of these
    const data = ['car', 'car', 'truck', 'truck', 'bike', 'walk', 'car', 
                  'van', 'bike', 'walk', 'car', 'van', 'car', 'truck' ];
    /*al momento de no querer hardcodear las string para el conteo, se hace una funcion
      donde declaramos obj e item, donde item seran los textos a contar, y despues de la funcion
      dejaremos un objeto bascio indicar que lo verifique, lo tome y lo guarde  el valor*/
    const transportation = data.reduce(function(obj, item){
      if(!obj[item]){
        obj[item] = 0;
      }
      obj[item]++;
      return obj;
    }, {});

    console.log(transportation);
  </script>
</body>
</html>
